-- PRAGMA temp_store_directory = '/share/data/CHomP/Projects/DSGRN/data/tmp';
CREATE INDEX IF NOT EXISTS MorseGraphAnnotations1 on MorseGraphAnnotations (MorseGraphIndex);
CREATE INDEX IF NOT EXISTS MorseGraphAnnotations3 on MorseGraphAnnotations (Label, MorseGraphIndex);
CREATE INDEX IF NOT EXISTS MorseGraphEdges1 on MorseGraphEdges (MorseGraphIndex);
CREATE INDEX IF NOT EXISTS MorseGraphVertices1 on MorseGraphVertices (MorseGraphIndex, Vertex);
CREATE INDEX IF NOT EXISTS MorseGraphVertices2 on MorseGraphVertices (Vertex, MorseGraphIndex);
CREATE INDEX IF NOT EXISTS MorseGraphViz2 on MorseGraphViz (Graphviz, MorseGraphIndex);
CREATE INDEX IF NOT EXISTS Signatures2 on Signatures (MorseGraphIndex, ParameterIndex);
create table TFP as select distinct MorseGraphIndex, 1 as FPC from MorseGraphAnnotations where Label="FP";
create table TFPON as select distinct MorseGraphIndex, 1 as FPONC from MorseGraphAnnotations where Label="FP ON";
create table TFPOFF as select distinct MorseGraphIndex, 1 as FPOFFC from MorseGraphAnnotations where Label="FP OFF";
create table TFC as select distinct MorseGraphIndex, 1 as FCC from MorseGraphAnnotations where Label="FC";
create table TXC as select distinct MorseGraphIndex, 1 as XCC from MorseGraphAnnotations where Label like "XC%";
create table MorseGraphFrequency as select MorseGraphIndex,count(*) as Frequency from Signatures group by MorseGraphIndex order by Frequency desc;
create table MGZ as select * from MorseGraphFrequency natural join MorseGraphviz;
create table MorseGraphZoo as select MorseGraphIndex, Frequency, GraphViz, ifnull(FPC, 0) as FP, ifnull(FPONC, 0) as FPON, ifnull(FPOFFC,0) as FPOFF, ifnull(FCC,0) as FC, ifnull(XCC,0) as XC  from MGZ natural left outer join TFP natural left outer join TFPON natural left outer join TFPOFF natural left outer join TFC natural left outer join TXC;
drop table TFP;
drop table TFPON;
drop table TFPOFF;
drop table TFC;
drop table TXC;
drop table MorseGraphFrequency;
drop table MGZ;
